extends Node


const Player = preload("./player.gd")

var player: Player
var scene_arg: Variant

var _use_workaround: CheckBox


func _init() -> void:
	var canvas_layer := CanvasLayer.new()

	_use_workaround = CheckBox.new()
	_use_workaround.text = "Use workaround"
	canvas_layer.add_child(_use_workaround)

	add_child(canvas_layer)


func _enter_tree() -> void:
	player = load("res://player.tscn").instantiate()


func _exit_tree() -> void:
	assert(not is_instance_valid(player.get_parent()))
	player.free()


func change_scene(path: String, arg: Variant = null) -> void:
	if _use_workaround.button_pressed:
		player.set_physics_process(false)
		player.collision_layer = 0

	await get_tree().process_frame
	scene_arg = arg
	get_tree().change_scene_to_file(path)

	if _use_workaround.button_pressed:
		await get_tree().physics_frame
		await get_tree().physics_frame
		player.collision_layer = 1
		player.set_physics_process(true)
